#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
import inspect
import gc
import numpy
from odict import odict
from task_pclean import pclean
from task_pclean import casalog

class pclean_pg_:
    __name__ = "pclean"

    def __init__(self) :
       self.__bases__ = (pclean_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, vis=None,imagename=None,imsize=None,cell=None,phasecenter=None,stokes=None,mask=None,field=None,spw=None,ftmachine=None,alg=None,scales=None,cyclefactor=None,majorcycles=None,niter=None,gain=None,threshold=None,weighting=None,robust=None,npixels=None,mode=None,nterms=None,start=None,nchan=None,width=None,restfreq=None,interactive=None,npercycle=None,wprojplanes=None,facets=None,overwrite=None,uvtaper=None,outertaper=None,timerange=None,uvrange=None,antenna=None,scan=None,observation=None,pbcor=None,minpb=None,clusterdef=None,):

        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        myf['__last_task'] = 'pclean'
        myf['taskname'] = 'pclean'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['vis'] = vis = myf['vis']
            myparams['imagename'] = imagename = myf['imagename']
            myparams['imsize'] = imsize = myf['imsize']
            myparams['cell'] = cell = myf['cell']
            myparams['phasecenter'] = phasecenter = myf['phasecenter']
            myparams['stokes'] = stokes = myf['stokes']
            myparams['mask'] = mask = myf['mask']
            myparams['field'] = field = myf['field']
            myparams['spw'] = spw = myf['spw']
            myparams['ftmachine'] = ftmachine = myf['ftmachine']
            myparams['alg'] = alg = myf['alg']
            myparams['scales'] = scales = myf['scales']
            myparams['cyclefactor'] = cyclefactor = myf['cyclefactor']
            myparams['majorcycles'] = majorcycles = myf['majorcycles']
            myparams['niter'] = niter = myf['niter']
            myparams['gain'] = gain = myf['gain']
            myparams['threshold'] = threshold = myf['threshold']
            myparams['weighting'] = weighting = myf['weighting']
            myparams['robust'] = robust = myf['robust']
            myparams['npixels'] = npixels = myf['npixels']
            myparams['mode'] = mode = myf['mode']
            myparams['nterms'] = nterms = myf['nterms']
            myparams['start'] = start = myf['start']
            myparams['nchan'] = nchan = myf['nchan']
            myparams['width'] = width = myf['width']
            myparams['restfreq'] = restfreq = myf['restfreq']
            myparams['interactive'] = interactive = myf['interactive']
            myparams['npercycle'] = npercycle = myf['npercycle']
            myparams['wprojplanes'] = wprojplanes = myf['wprojplanes']
            myparams['facets'] = facets = myf['facets']
            myparams['overwrite'] = overwrite = myf['overwrite']
            myparams['uvtaper'] = uvtaper = myf['uvtaper']
            myparams['outertaper'] = outertaper = myf['outertaper']
            myparams['timerange'] = timerange = myf['timerange']
            myparams['uvrange'] = uvrange = myf['uvrange']
            myparams['antenna'] = antenna = myf['antenna']
            myparams['scan'] = scan = myf['scan']
            myparams['observation'] = observation = myf['observation']
            myparams['pbcor'] = pbcor = myf['pbcor']
            myparams['minpb'] = minpb = myf['minpb']
            myparams['clusterdef'] = clusterdef = myf['clusterdef']

        if type(imsize)==int: imsize=[imsize]
        if type(cell)==float: cell=[cell]
        if type(scales)==int: scales=[scales]
        if type(outertaper)==str: outertaper=[outertaper]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['imagename'] = imagename
        mytmp['imsize'] = imsize
        if type(cell) == str :
           mytmp['cell'] = casac.quanta().quantity(cell)
        else :
           mytmp['cell'] = cell
        mytmp['phasecenter'] = phasecenter
        mytmp['stokes'] = stokes
        mytmp['mask'] = mask
        mytmp['field'] = field
        mytmp['spw'] = spw
        mytmp['ftmachine'] = ftmachine
        mytmp['alg'] = alg
        mytmp['scales'] = scales
        mytmp['cyclefactor'] = cyclefactor
        mytmp['majorcycles'] = majorcycles
        mytmp['niter'] = niter
        mytmp['gain'] = gain
        mytmp['threshold'] = threshold
        mytmp['weighting'] = weighting
        mytmp['robust'] = robust
        mytmp['npixels'] = npixels
        mytmp['mode'] = mode
        mytmp['nterms'] = nterms
        mytmp['start'] = start
        mytmp['nchan'] = nchan
        mytmp['width'] = width
        mytmp['restfreq'] = restfreq
        mytmp['interactive'] = interactive
        mytmp['npercycle'] = npercycle
        mytmp['wprojplanes'] = wprojplanes
        mytmp['facets'] = facets
        mytmp['overwrite'] = overwrite
        mytmp['uvtaper'] = uvtaper
        mytmp['outertaper'] = outertaper
        mytmp['timerange'] = timerange
        mytmp['uvrange'] = uvrange
        mytmp['antenna'] = antenna
        mytmp['scan'] = scan
        mytmp['observation'] = observation
        mytmp['pbcor'] = pbcor
        mytmp['minpb'] = minpb
        mytmp['clusterdef'] = clusterdef
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'pclean.xml')

        casalog.origin('pclean')
        if not trec.has_key('pclean') or not casac.utils().verify(mytmp, trec['pclean']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: pclean           #####')
          casalog.post('')
          result = pclean(vis, imagename, imsize, cell, phasecenter, stokes, mask, field, spw, ftmachine, alg, scales, cyclefactor, majorcycles, niter, gain, threshold, weighting, robust, npixels, mode, nterms, start, nchan, width, restfreq, interactive, npercycle, wprojplanes, facets, overwrite, uvtaper, outertaper, timerange, uvrange, antenna, scan, observation, pbcor, minpb, clusterdef)
          casalog.post('')
          casalog.post('##### End Task: pclean           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('pclean', 'pclean.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'pclean'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        a=inspect.stack()
#        stacklevel=0
#        for k in range(len(a)):
#          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
#            stacklevel=k
#            break
#        myf = sys._getframe(stacklevel).f_globals
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('pclean', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        a = odict()
        a['vis']  = ''
        a['imagename']  = ''
        a['imsize']  = [256, 256]
        a['cell']  = ['1.0arcsec', '1.0arcsec']
        a['phasecenter']  = ''
        a['stokes']  = 'I'
        a['mask']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['ftmachine']  = 'ft'
        a['alg']  = 'multiscale'
        a['cyclefactor']  = 1.5
        a['niter']  = 500
        a['gain']  = 0.1
        a['threshold']  = '0.0Jy'
        a['weighting']  = 'natural'
        a['mode']  = 'continuum'
        a['interactive']  = False
        a['overwrite']  = True
        a['uvtaper']  = False
        a['timerange']  = ''
        a['uvrange']  = ''
        a['antenna']  = ''
        a['scan']  = ''
        a['observation']  = ''
        a['pbcor']  = False
        a['minpb']  = 0.2
        a['clusterdef']  = ''

        a['mode'] = {
                    0:odict([{'value':'continuum'}, {'nterms':1}]), 
                    1:odict([{'value':'mfs'}, {'nterms':1}]), 
                    2:odict([{'value':'cube'}, {'start':0}, {'nchan':2}, {'width':1}, {'restfreq':''}]), 
                    3:odict([{'value':'channel'}, {'start':0}, {'nchan':2}, {'width':1}, {'restfreq':''}]), 
                    4:odict([{'value':'frequency'}, {'start':'0GHz'}, {'nchan':2}, {'width':'1Hz'}, {'restfreq':''}]), 
                    5:odict([{'value':'velocity'}, {'start':'0km/s'}, {'nchan':2}, {'width':'1m/s'}, {'restfreq':''}])}
        a['cyclefactor'] = {
                    0:{'value':1.5}, 
                    1:odict([{'value':0.0}, {'majorcycles':1}])}
        a['ftmachine'] = {
                    0:{'value':'ft'}, 
                    1:odict([{'value':'wproject'}, {'wprojplanes':128}, {'facets':1}]), 
                    2:{'value':'mosaic'}, 
                    3:{'value':'sd'}}
        a['alg'] = {
                    0:odict([{'value':'multiscale'}, {'scales':[0]}]), 
                    1:{'value':'clark'}, 
                    2:{'value':'hogbom'}}
        a['weighting'] = {
                    0:{'value':'natural'}, 
                    1:{'value':'radial'}, 
                    2:{'value':'uniform'}, 
                    3:odict([{'value':'briggs'}, {'robust':0.0}, {'npixels':0}]), 
                    4:odict([{'value':'briggsabs'}, {'npixels':0}, {'robust':0.0}]), 
                    5:{'value':'radial'}, 
                    6:odict([{'value':'superuniform'}, {'npixels':0}])}
        a['uvtaper'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'outertaper':[]}])}
        a['interactive'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'npercycle':100}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      a=inspect.stack() 
      stacklevel=0
      for k in range(len(a)):
        if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
	    stacklevel=k
	    break
      myf=sys._getframe(stacklevel).f_globals

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['imagename']  = ''
        a['imsize']  = [256, 256]
        a['cell']  = ['1.0arcsec', '1.0arcsec']
        a['phasecenter']  = ''
        a['stokes']  = 'I'
        a['mask']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['ftmachine']  = 'ft'
        a['alg']  = 'multiscale'
        a['scales']  = [0]
        a['cyclefactor']  = 1.5
        a['majorcycles']  = 1
        a['niter']  = 500
        a['gain']  = 0.1
        a['threshold']  = '0.0Jy'
        a['weighting']  = 'natural'
        a['robust']  = 0.0
        a['npixels']  = 0
        a['mode']  = 'continuum'
        a['nterms']  = 1
        a['start']  = 0
        a['nchan']  = 1
        a['width']  = 1
        a['restfreq']  = ''
        a['interactive']  = False
        a['npercycle']  = 100
        a['wprojplanes']  = 128
        a['facets']  = 1
        a['overwrite']  = True
        a['uvtaper']  = False
        a['outertaper']  = ['']
        a['timerange']  = ''
        a['uvrange']  = ''
        a['antenna']  = ''
        a['scan']  = ''
        a['observation']  = ''
        a['pbcor']  = False
        a['minpb']  = 0.2
        a['clusterdef']  = ''

        if a.has_key(paramname) :
	      return a[paramname]
pclean_pg = pclean_pg_()
